part of tecfy_core_client_package;

class DashboardController extends BaseController {
  List<DashboardItemBase> types;

  RefreshController refreshController =
      RefreshController(initialRefresh: false); // for pull to refrsh

  DashboardController(State<StatefulWidget> state) : super(state) {
    getType();
  }

  @override
  dispose() {
    refreshController?.dispose();
    super.dispose();
  }

  getType() async {
    try {
      var typesResult = await ApiService.httpGetDynamic('Dashboard/GetTypes');
      if (!typesResult.success) {
        typesResult.data =
            jsonDecode(ConfigService.getValueString('DashboardType'));
        typesResult.success = typesResult.data != null;
      }
      if (typesResult.success) {
        ConfigService.setValueString(
            'DashboardType', jsonEncode(typesResult.data));
        types = typesResult.data
            .map<DashboardItemBase>((d) => DashboardItemBase.fromMap(d))
            .toList();
        setState();
      }
    } catch (err) {
      print('XXXXXXXXXXXXX getType in dashboard  $err');
    }
  }

  Future<void> refreshData() async {
    types.forEach((t) => t.value = null);
    types.forEach((t) => getData(t));
    await Future.delayed(Duration(seconds: 1));
    refreshController.refreshCompleted();
  }

  Future<dynamic> getData(DashboardItemBase type) async {
    if (type.value != null) return type.value;
    if (type.value == -1) return null;
    type.value = -1;

    var result =
        await ApiService.httpGetDynamic('Dashboard/GetData/${type.dbName}');
    if (!result.success) {
      result.data = jsonDecode(
          ConfigService.getValueString('DashboardType${type.dbName}'));
      result.success = result.data != null;
    }
    if (result.success) {
      ConfigService.setValueString(
          'DashboardType${type.dbName}', jsonEncode(result.data));
      type.value = result.data;
    } else {
      type.value = '0';
    }
    setState();
    return type.value;
  }
}
