part of tecfy_core_client_package;

class PropertyDate extends Property {
  DateTime minDate;
  DateTime maxDate;

  bool isTodayByDefault;

  bool isAllowFuture = true;
  bool isAllowPast = true;

  /// <summary>
  /// yyyy-MM-dd    (default)
  /// dd/MM/yyyy
  /// </summary>
  String format = "yyyy-MM-dd";

  PropertyDate.fromMap(Map row) : super.fromMap(row) {
    minDate = getDateFromJsonString(row['minDate'] ?? '2000-01-01');
    maxDate = getDateFromJsonString(row['maxDate'] ?? '2050-01-01');
    isTodayByDefault = row['isTodayByDefault'] ?? false;
    isAllowFuture = row['isAllowFuture'] ?? true;
    isAllowPast = row['isAllowPast'] ?? true;
    format = row['format'] ?? 'yyyy-MM-dd e';
  }

  DateTime getDateFromJsonString(String value) {
    return BaseModel.parseUTC(value);
  }

  @override
  OperationResult isValid(data) {
    if (!super.isValid(data).success) return super.isValid(data);

    return OperationResult(success: true);
  }

  Widget getDisplayWidget(Map data,
      {double size = 12, Color color = Colors.black}) {
    //print('date   ' + data[dbName] + '----' + format);
    var date = BaseModel.parseUTC(data[dbName]);

    return Text(
        date == null
            ? ''
            : intl.DateFormat(format ?? "yyyy-MM-dd HH:mm")
                .format(date.toLocal()),
        style: TextStyle(fontSize: size, color: color));

    //return Text(data[dbName]?.toString()?.substring(0,10) ?? '',style:TextStyle(fontSize: size,color:color));
  }

  Future<bool> getDefaultValue(Map<String, dynamic> data) async {
    if (data[dbName] != null) return false;
    if (isTodayByDefault) {
      data[dbName] = DateTime.now().toUtc();
      return true;
    }
    return false;
  }
}
