part of tecfy_core_client_package;

class LocalConfigService {
  static bool get isArabic => (language == Language.arabic);
  static String get languagePrefex => (language == Language.arabic) ? 'Ar' : 'En';

  static Language get language {
    var value = ConfigService.getValueInt(ConfigKeys.language);
    var lang = value == 0
        ? Language.arabic
        : Language.values[value] ?? Language.english;
    return lang;
  }

  static User get user =>
      User.fromJson(ConfigService.getValueMap(ConfigKeys.user));

  static Future<bool> saveUser(User u) =>
      ConfigService.setValueMap(ConfigKeys.user, u.toJson());

  static set language(Language v) {
    ConfigService.setValueInt(ConfigKeys.language, v.index).then((d){
      ConfigService.isRTL = (v == Language.arabic);
      AppLocale.languageStreamController.add(LocalConfigService.language);
    });
  }
}

enum ConfigKeys { user, language, company }
enum Language { notSelected, arabic, english }
