part of tecfy_core_client_package;

class AccountPage extends StatefulWidget {
  @override
  _AccountPageState createState() => _AccountPageState();
}

class _AccountPageState extends AppState<AccountPage> {
  User user;
  String password;

  initState() {
    user = LocalConfigService.user;
    super.initState();
  }

  Future<dynamic> _onSave() async {
    Map<String, String> data = Map<String, String>();
    data['password'] = password;
    data['fullName'] = user.fullName;
    data['email'] = user.email;
    data['mobile'] = user.mobile;
    var result = await ApiService.httpPostEx(
        'user/updateMyInfo',
        json
            .encode(data, toEncodable: EntityService.customEncode)
            .replaceAll('\"', '\''));
    print(result);
    if (!result.success) {
      result.showMessage(context);
      return;
    }
    // save local
    LocalConfigService.saveUser(user);
    // show success message
    await AppNavigator.showMessage(context,'Data Saved Successfully!');
    //exit
    AppNavigator.pop(context, user);
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(
      context,
      trans('Account Setting'),
      appBarActions: <Widget>[
        LayoutService.isMobile(context)
            ? IconButton(
                icon: Icon(Icons.save, color: ThemeService.mainColor),
                //color: ThemeService.secondryColor,
                tooltip: trans('Save'),
                onPressed: ()=> _onSave())
            : AppButtonIconText(
                icon: Icon(Icons.save, color: ThemeService.textOnMainColor),
                color: ThemeService.secondryColor,
                label: trans('Save'),
                onPressed: _onSave)
      ],
      child: Align(
        alignment: Alignment.topCenter,
        child: Container(
          constraints: BoxConstraints(maxWidth: ThemeService.containerWidth),
          child: ListView(
              padding: EdgeInsets.symmetric(horizontal: 20),
              children: [
                PorpertyComponent(
                  property: PropertyText(
                    dbName: 'fullName',
                    nameAr: 'الاسم',
                    nameEn: 'Name',
                  ),
                  data: {'fullName': user.fullName},
                  onChange: (v) => user.fullName = v,
                ),
                PorpertyComponent(
                  property: PropertyText(
                      dbName: 'username',
                      nameAr: 'اسم المستخدم للدخول',
                      nameEn: 'Login Username'),
                  data: {'username': user.username},
                  readOnly: true,
                  onChange: (v) => user.username = v,
                ),
                PorpertyComponent(
                  property: PropertyText(
                      isEmail: true,
                      dbName: 'email',
                      nameAr: 'الايميل',
                      nameEn: 'email'),
                  data: {'email': user.email},
                  onChange: (v) => user.email = v,
                ),
                PorpertyComponent(
                  property: PropertyText(
                      dbName: 'mobile', nameAr: 'الموبايل', nameEn: 'mobile'),
                  data: {'mobile': user.mobile},
                  onChange: (v) => user.mobile = v,
                ),
                PorpertyComponent(
                  property: PropertyText(
                      dbName: 'password',
                      nameAr: 'الرقم السري',
                      nameEn: 'password',
                      isPassword: true),
                  data: {'password': null},
                  onChange: (v) => password = v,
                ),
              ]),
        ),
      ),
    );
  }
}
