part of tecfy_core_client_package;

class ManyToManyProperty extends StatefulWidget {
 final List<dynamic> selectedValues;
  final Entity entity;
  final String label;
  final bool isRequired;
  final void Function(List<dynamic>) onChanged; 
 ManyToManyProperty({this.selectedValues,this.onChanged,this.entity,this.isRequired,this.label});
  @override
  _ManyToManyPropertyState createState() => _ManyToManyPropertyState();
}

class _ManyToManyPropertyState extends State<ManyToManyProperty> {

  List<dynamic> data;
  List<dynamic> selectedValues=[];

  @override
  void initState() {
    
    EntityService().getData(widget.entity).then((result){
      if(result.success){
        data = result.data;
        selectedValues = data.where((i)=> widget.selectedValues.contains(i['id'])).toList();
        setState(() {});
      }else result.showMessage(context);
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
   return FlatButton(
      padding: EdgeInsets.all(0),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[
          SizedBox(height: 25.0),
          selectedValues.length == 0
              ? Padding(padding:EdgeInsets.only(bottom: 10.0),child:Text('${widget.label}${widget.isRequired ? '*' :''}',style: TextStyle(fontSize: 20, fontWeight: FontWeight.normal)))
              : Wrap(
                  spacing: 3.0,
                  children: selectedValues
                      .map((d) =>
                          Chip(label: Text(d['display'])))
                      .toList()),
          //style:TextStyle(fontSize: 18.0, color: Colors.black)),
          SizedBox(height: 5.0),
          Container(
            // margin: EdgeInsetsDirectional.only(start: 1.0, end: 1.0),
            height: 1.0,
            color: Colors.black,
          ),
          SizedBox(height: 20.0),
        ],
      ),
      onPressed: () {
        openMultiSelectDialog();
      },
    );
  }

   openMultiSelectDialog() {
    AppNavigator.showAppDialog(
        context,
        (_) => MultiSelectDialog(data, selectedValues, (d) {
              if(d != null){
                  var dd = d.map((i)=>i['id']).toList();
                  widget.onChanged(dd);
              }
              setState(() {});
            }),animationType: AnimationTypes.slideUp);
  }
}