part of tecfy_core_client_package;

abstract class AppStateView<T extends StatefulWidget, C extends BaseController>
    extends State<T> {
  C _controller;

  @override
  dispose() {
    _controller?.dispose();
    super.dispose();
  }

  String trans(String text) {
    if (text == null || text.isEmpty) return '';
    return AppLocale.translate(context, text);
  }
}

abstract class AppState<T extends StatefulWidget> extends State<T> {
  String trans(String text) {
    if (text == null || text.isEmpty) return '';
    return AppLocale.translate(context, text);
  }

  dateFormat(DateTime date,
          {String format = 'dd/MM/yyyy', String whenNull = ''}) =>
      date == null ? whenNull : intl.DateFormat(format).format(date.toLocal());
}
